require 'spec_helper'

describe Benchmark do

end

def verify_labels(output)
  available_labels = %w(Test1, Test2, Test3, Test4, Test5, Test6)
  valid_label = true
  output.each do |out|
    valid_label = available_labels.include? out.label
  end
  valid_label

end

describe '#penchmark' do
  it 'penchmark should have labels in rows according to test block' do
    n = 2000
    output = Benchmark.penchmark(CAPTION, 7, FORMAT, '>total:', '>:avg') do |x|
      tt = x.report('Test1', 0, 0.002) do
        for i in 1..n
          a = '1'
        end
      end

      tb = x.report('Test2', 0, 0.01) do
        for i in 1..n
          a = '1'
        end
      end

      tc = x.report('Test3', 0, 0.6) do
        for i in 1..n*400
          a = '1'
        end
      end

      td = x.report('Test4', 0, 0.7) do
        for i in 1..n*200
          a = '1'
        end
      end

      x.report('Test5', 0, 0.2) do
        for i in 1..n
          a = '1'
        end
      end

      x.report('Test6', 0, 0.9) do
        for i in 1..n
          a = '1'
        end
      end

      [tt+tb+tc+td, (tt+tb+tc+td)/3]
    end

    valid_label = verify_labels(output)
    valid_label.should be_true

  end

  it "pbm should return a list of predefined labels" do
    n = 10000
    output = Benchmark.pbm do |x|
      x.report("Test1") do
        for i in 1..n
          a = "1"
        end
      end

      x.report("Test2") do
        for i in 1..n
          a = "1"
        end
      end

      x.report("Test3") do
        for i in 1..n*400
          a = "1"
        end
      end

      x.report("Test4") do
        for i in 1..n
          a = "1"
        end
      end

      x.report("Test5") do
        for i in 1..n
          a = "1"
        end
      end

      x.report("Test6") do
        for i in 1..n
          a = "1"
        end
      end
    end

    valid_label = verify_labels(output)
    valid_label.should be_true
  end
end